--#region vars
font = love.graphics.newFont("1980XX.ttf", 32)
xIcon = love.graphics.newImage("x.png")
a = 0
pos = {x = 250, y = 250}
vel = {x = 0, y = 0}
snakeParts = {}
numOfParts = 0
playArea = 0
fruits = {}
points = 1
color = {{.3, .7, .3, 1}, {.7, .7, .3, 1}, {.3, .7, .7, 1}, {.3, .3, .3, 1}, {.7, .5, .3, 1}, {.5, .5, .7, 1}, {1, 1, 1, 1}}
--#endregion

function love.load(arg)
  love.graphics.setFont(font)
  for i=1,1200 do
    table.insert(snakeParts, {x = pos.x, y = pos.y})
  end
end

function love.update(dt)
  if playArea < 0 then
    playArea = 0
  elseif playArea > 220 then
    playArea = 220
  end
  --#region a
  if love.mouse.getX() >= 470 and love.mouse.getY() <= 25 and love.mouse.getX() <= 498 and love.mouse.getY() >= 1 then
    a = 1
    if love.mouse.isDown(1) then
      love.event.quit()
    end
  else
    a = 0
  end

  if (love.keyboard.isDown("up") or love.keyboard.isDown("w")) and vel.y > -2 then
    vel.y = vel.y - 2*dt
  end
  if (love.keyboard.isDown("down") or love.keyboard.isDown("s")) and vel.y < 2 then
    vel.y = vel.y + 2*dt
  end

  if (love.keyboard.isDown("right") or love.keyboard.isDown("d")) and vel.x < 2 then
    vel.x = vel.x + 2*dt
  end
  if (love.keyboard.isDown("left") or love.keyboard.isDown("a")) and vel.x > -2 then
    vel.x = vel.x - 2*dt
  end

  if not (love.keyboard.isDown("w") or love.keyboard.isDown("s")) then
    b1 = GoTo(vel.y, 0, 50)
    vel.y = vel.y-b1
  end
  if not (love.keyboard.isDown("d") or love.keyboard.isDown("a")) then
    b2 = GoTo(vel.x, 0, 50)
    vel.x = vel.x-b2
  end

  if pos.x <= 42 then
    if vel.x <= 0 then
      vel.x = 0
    end
  end
  if pos.x >= 458 then
    if vel.x >= 0 then
      vel.x = 0
    end
  end
  if pos.y <= 67 then
    if vel.y <= 0 then
      vel.y = 0
    end
  end
  if pos.y >= 483 then
    if vel.y >= 0 then
      vel.y = 0
    end
  end

  pos.x, pos.y = pos.x + vel.x, pos.y + vel.y
  --#endregion
  getTime(dt)
  fruitGen(dt)
  for i=#fruits,1,-1 do
    if pos.x == nil or pos.y == nil or fruits[i] == nil then
      a = 0
    elseif overlapDetection(pos.x, pos.y, 12, 12, fruits[i].x or 0, fruits[i].y or 0, 10, 10) then
      numOfParts = numOfParts + 1+math.floor((points-1)/5)
      playArea = playArea - (points*(math.floor((points-1)/5)+2))
      if numOfParts >= 12 then
        T12()
      end
      table.remove(fruits, i)
    end
  end
  playArea = playArea + dt*points*2

  if pos.x > 470-playArea or pos.x < 30+playArea or pos.y < 55+playArea or pos.y > 495-playArea then
    snakeDie(dt)
  else
    time2 = 0
  end
end

function love.draw()

  --#region b
  love.graphics.setColor(.7, .15, .15, 1)

  --"GUI"
  love.graphics.setBackgroundColor(.15, .15, .15, 1)
  --title
  love.graphics.printf("Snake12", 0, 25, 500, "center")
  --bar
  love.graphics.setColor(1, 1, 1, 0.05)
  love.graphics.rectangle("fill", 0, 0, 525, 25)
  --shadow
  love.graphics.setColor(1, 1, 1, 0.1)
  love.graphics.rectangle("fill", 50, 75, 440, 440)
  --play area .3, .7, .3, 1
  love.graphics.setColor(color[math.floor((points-1)/5)+1] or {1,1,1,1})
  --love.graphics.setColor(.3, .7, .3, 1)
  love.graphics.rectangle("fill", 30, 55, 440, 440)

  love.graphics.setColor(.7, .15, .15, a)
  love.graphics.rectangle("fill", 468, 0, 32, 25)
  love.graphics.setColor(1, 1, 1, 1)
  love.graphics.draw(xIcon, 470, -2, 0, 0.018, 0.018)
  --love.graphics.print(tostring(pos.y), 10, 50)
  --#endregion

  for i=1, #fruits do
    love.graphics.setColor(.4, .15, .15, 1)
    love.graphics.circle("fill", fruits[i].x, fruits[i].y, 7, 50)
  end

  for i=numOfParts, 1, -1 do
    if i%2 == 0 then
      love.graphics.setColor(.7, .15, .15, 1)
    else
      love.graphics.setColor(.7, .5, .15, 1)
    end
    love.graphics.circle("fill", snakeParts[#snakeParts-(i*5)].x, snakeParts[#snakeParts-(i*5)].y, 13-i, 50)
  end

  love.graphics.setColor(.7, .15, .15, 1)
  love.graphics.circle("fill", pos.x, pos.y, 12, 50)

  love.graphics.setColor(.7, .5, .15, 1)
  love.graphics.print("cycles: "..tostring(points-1), 30, 25)
  love.graphics.print("size: "..tostring(numOfParts), 390, 25)
  love.graphics.print("press R to reset", 410, 512, 0, .5, .5)

  love.graphics.setColor(0, 0, 0, 0.2)
  love.graphics.rectangle("fill", 30, 55, playArea, 440)
  love.graphics.rectangle("fill", 470, 55, -playArea, 440)
  love.graphics.rectangle("fill", 30+playArea, 55, 440-playArea*2, playArea)
  love.graphics.rectangle("fill", 30+playArea, 495, 440-playArea*2, -playArea)

  love.graphics.setColor(0, 0, 0, 1)
  if numOfParts < 0 then
    dieMessage()
  end
end

function getTime (dt)
  table.insert(snakeParts, {x = pos.x, y = pos.y})
end

time_ = 1
function fruitGen (dt)
  math.randomseed(os.time())
  time_ = time_ + dt
  if time_ >= 2-(math.floor((points-1)/5))*0.25 then
    x_ = love.math.random(35+playArea, 465-playArea)
    y_ = love.math.random(60+playArea, 490-playArea)
    table.insert(fruits, {x = x_, y = y_})
    time_ = 0
  end
end

function GoTo (num, num2, time)
  num = (num-num2)/time
  return num
end

function overlapDetection (x1, y1, w1, h1, x2, y2, w2, h2)
  if x1+w1/2 >= x2-w2/2 and y1+h1/2 >= y2-h2/2 and x1-w1/2 <= x2+w2/2 and y1-h1/2 <= y2+h2/2 then
    return true
  else
    return false
  end
end

function T12 ()
  fruits = {}
  points = points + 1
  playArea = 0
  numOfParts = 0
end

time2 = 0
function snakeDie (dt)
  time2 = time2+dt*2
  if time2 > 1 then
    numOfParts = numOfParts-(math.floor((points-1)/5)+1)
    time2 = 0
  end
end

function dieMessage ()
  love.graphics.setColor(1, 1, 1, 1)
  love.graphics.rectangle("fill", 0, 25, 111111, 11111)

  love.graphics.setColor(0, 0, 0, 1)
  love.graphics.printf("Scored: "..tostring(points-1), 0, 265, 500, "center", 0, 1, 1)
  love.graphics.printf("You died", 0, 250, 500, "center", 0, 1, 1)
end

function love.keypressed(key, scancode, isrepeat)
  if key == "r" then
    love.event.quit("restart")
  end
end
